if [ ! -d /proc/ide ]; then 
	exit
fi
CHANNELS=`ls -d /proc/ide/ide*|cut -d/ -f 4`
#!/bin/bash
hdparm=/sbin/hdparm
function parse_hdparm {
	while read line; do
		if [[ $line == Model* ]]; then
			model=${line%%,*}
			echo -n " model='${model##Model=}'"
			fwrev=${line%%, Serial*}
			echo -n " firmware='${fwrev##*FwRev=}'"
			serial=${line##*SerialNo=}
			echo -n " serial='$serial'"
		elif [[ $line == using_dma* ]]; then
			dma=${line##using_dma*=??}
			echo -n " dmastate='$dma'"
		elif [[ $line == busstate* ]]; then
			busstate=${line##busstate*=??}
			echo -n " busstate='$busstate'"
		elif [[ $line == readahead* ]]; then
			readahead=${line##readahead*=??}
			echo -n " readahead='$readahead'"
			
		fi
	done
}
for i in $CHANNELS; do
	echo "<idechannel channel='${i##ide}'>"
	for j in `ls -d /proc/ide/$i/hd*|cut -d/ -f 5`; do
		echo -n "<idedisk name='$j'"
		$hdparm -i /dev/$j | parse_hdparm
		$hdparm  /dev/$j | parse_hdparm
		echo -n " type='`cat /proc/ide/$i/$j/media`'"
		echo "></idedisk>"
	done
	echo "</idechannel>"
done
