IFCONFIG=/sbin/ifconfig
DEVS=`${IFCONFIG} -a |grep "^[^ ]"|cut -d ' ' -f 1`
#DEVS=myri0
shopt -s extglob

function get_myri_info {
	/opt/gm/bin/gm_board_info | (
	#cat myri_out.sample | grep -v ^$ | (
	while read line; do
		if [ "${line%%\"*}" == "GM build ID is " ]; then
			TMP=${line#*\"}
			TMP=${TMP%\"}
			echo -n " build_id='$TMP'"
		elif [[ "${line}" == Board\ number* ]]; then
			PREFIX="${line#Board number }"
			PREFIX=${PREFIX%:}
			if [ "$PREFIX" == "${1##myri}" ]; then
				STATE="READ"
			fi
		fi

		if [ "$STATE" != READ ]; then
			continue
		fi
		if [[ "$line" == lanai_clockval* ]]; then
			echo -n " clockval='${line##lanai_clockval*( |	)=*(	| )}'"
		elif [[ "$line" == lanai_cpu_version* ]]; then
			echo -n " cpu_version='${line##lanai_cpu_version*( |	)=*( |	)}'"
		elif [[ "$line" == lanai_board_id* ]]; then
			echo -n " realmac='${line##lanai_board_id*( |	)=*( |	)}'"
		elif [[ "$line" == lanai_sram_size* ]]; then
			echo -n " sram='${line##lanai_sram_size*( |	)=*( |	)}'"
		elif [[ "$line" == max_lanai_speed* ]]; then
			echo -n " max_lanai_speed='${line##max_lanai_speed*( |	)=*( |	)}'"
		elif [[ "$line" == product_code* ]]; then
			echo -n " product_code='${line##product_code*( |	)=*( |	)}'"
		elif [[ "$line" == serial_number* ]]; then
			echo -n " serial='${line##serial_number*( |	)=*( |	)}'"
		elif [[ "$line" == *labeled:* ]]; then
			LABEL=${line#*\"}
			echo -n " label='${LABEL%\"*}'"
		fi

	done) 
}

function get_extended_information {
	if [[ "$1" == myri[0123456789] ]]; then
		get_myri_info $1
		return
	fi
	if [ -f /proc/net/PRO_LAN_Adapters/$1.info ]; then
		FILE=/proc/net/PRO_LAN_Adapters/$1.info
	elif [ -f /proc/net/nicinfo/$1.info ]; then
		FILE=/proc/net/nicinfo/$1.info
	else
		return
	fi
	DESC=`grep Description $FILE`
	echo -n " desc='${DESC##Description+(	| )}'"
	SPEED=`grep PCI_Bus_Speed\[\ \	\] $FILE`
	if [ ! -z "$SPEED" ]; then
		echo -n " bus_speed='${SPEED##PCI_Bus_Speed+(	| )}'"
	fi
	BUSTYPE=`grep -E '^PCI_Bus_Width[ 	]' $FILE`
	if [ ! -z "$BUSTYPE" ]; then
		echo -n " bus_width='${BUSTYPE##PCI_Bus_Width+(	| )}'"
	fi
	PARTNUM=`grep -E '^Part_Number[ 	]' $FILE`
	if [ ! -z "$PARTNUM" ]; then
		echo -n " part_number='${PARTNUM##Part_Number+(	| )}'"
	fi
	MEMORY=`grep -E '^Memory[ 	]' $FILE`
	if [ ! -z "$MEMORY" ]; then
		echo -n " memory='${MEMORY##Memory+(	| )}'"
	fi
	IRQ=`grep -E '^IRQ[ 	]' $FILE`
	if [ ! -z "$IRQ" ]; then
		echo -n " irq='${IRQ##IRQ+(	| )}'"
	fi
	BUSTYPE=`grep -E '^PCI_Bus_Type[ 	]' $FILE`
	if [ ! -z "$BUSTYPE" ]; then
		echo -n " bus_type='${BUSTYPE##PCI_Bus_Type+(	| )}'"
	fi
	POLARITY=`grep -E ^PHY_Cable_Polarity\[\ \	\] $FILE`
	if [ ! -z "$POLARITY" ]; then
		echo -n " cable_polarity='${POLARITY##PHY_Cable_Polarity+(	| )}'"
	fi
	LENGTH=`grep -E ^PHY_Cable_Length\[\ \	\] $FILE`
	if [ ! -z "$LENGTH" ]; then
		echo -n " cable_length='${LENGTH##PHY_Cable_Length+(	| )}'"
	fi
	MEDIA=`grep -E ^PHY_Media_Type\[\ \	\] $FILE`
	if [ ! -z "$MEDIA" ]; then
		echo -n " media='${MEDIA##PHY_Media_Type+(	| )}'"
	fi
	DRIVER=`grep -E ^Driver_Name\[\ \	\] $FILE`
	if [ ! -z "$DRIVER" ]; then
		echo -n " driver='${DRIVER##Driver_Name+(	| )}'"
	fi
	DRIVERVER=`grep -E ^Driver_Version\[\ \	\] $FILE`
	if [ ! -z "$DRIVERVER" ]; then
		echo -n " driver_version='${DRIVERVER##Driver_Version+(	| )}'"
	fi
	BOOTCODEVER=`grep -E ^Bootcode_Version\[\ \	\] $FILE`
	if [ ! -z "$BOOTCODEVER" ]; then
		echo -n " bootcode_version='${BOOTCODEVER##Bootcode_Version+(	| )}'"
	fi
	SPEEDS=`grep ^Speed_Advertisement\[\ \	\]  $FILE`
	if [ ! -z "$SPEEDS" ]; then
		echo -n " supported_speeds='${SPEEDS##Speed_Advertisement+(	| )}'"
	fi
	WOL=`grep Wake_On_LAN\[\ \	\] $FILE`
	if [ ! -z "$WOL" ]; then
		echo -n " wake_on_lan='${WOL##Wake_On_LAN+(	| )}'"
	fi
	SPEED=`grep ^Speed\[\ \	\]  $FILE`
	if [ ! -z "$SPEED" ]; then
		echo -n " speed='${SPEED##Speed+(	| )}'"
	fi
	DUPLEX=`grep ^Duplex\[\ \	\]  $FILE`
	if [ ! -z "$DUPLEX" ]; then
		echo -n " duplex='${DUPLEX##Duplex+(	| )}'"
	fi
	STATE=`grep ^State\[\ \	\]  $FILE`
	if [ ! -z "$STATE" ]; then
		echo -n " state='${STATE##State+(	| )}'"
	fi
	REALMAC=`grep ^Permanent_HWaddr\[\ \	\] $FILE`
	if [ ! -z "$REALMAC" ]; then
		echo -n " realmac='${REALMAC##Permanent_HWaddr+(	| )}'"
	fi
	
}
for dev in $DEVS
do
	echo -n "<net device='$dev'"
	${IFCONFIG} $dev |grep "MTU" | sed -e s/.*MTU/MTU/ |awk '{print $1}' | awk -F: \{printf\ \"\ mtu=\'%d\'\"\,\$2\}
	${IFCONFIG} $dev |grep "RX packets"|awk '{print $2 ":" $3 ":" $4 ":" $5}'|awk -F: \{printf\ \"\ rxpackets=\'%s\'\ rxerr=\'%s\'\ rxdrop=\'%s\'\ rxoverruns=\'%s\'\",\$2,\$4,\$6\,\$8}
	${IFCONFIG} $dev |grep "TX packets"|awk '{print $2 ":" $3 ":" $4 ":" $5}'|awk -F: \{printf\ \"\ txpackets=\'%s\'\ txerr=\'%s\'\ txdrop=\'%s\'\ txoverruns=\'%s\'\",\$2,\$4,\$6\,\$8}
	echo -n " collisions='`${IFCONFIG} $dev |grep collisions|awk '{print $1}'|awk -F: '{print $2}'`'"
	echo -n " mac='`${IFCONFIG} eth0 |grep HWaddr|awk '{print $5}'`'"

	if [ ! -z "`${IFCONFIG} $dev | grep UP`" ]
	then
		${IFCONFIG} $dev|grep inet | awk '{print $2 ":" $3 ":" $4}'|awk -F: \{printf\ \"\ up=\'1\'\ ipaddr=\'%s\'\ broadcast=\'%s\'\ netmask=\'%s\'\",\$2,\$4,\$6\}
	else
		echo -n " up='0'"
	fi
	get_extended_information $dev
	echo "></net>"
done

