unset IFS 
function parallel_query {
for i in $*; do 
	(
	scp -r client $i:/tmp/hwsclient  >& /dev/null
	ssh $i /tmp/hwsclient/survey.sh >> cluster.xml.$i 2> /dev/null
	ssh $i rm -rf /tmp/hwsclient  >& /dev/null
	rm -f $i.notdone
	) &
done 2> /dev/null  
}

function serial_query {
for i in $*; do 
	echo Querying $i:
	echo -n Installing software:
	scp -r client $i:/tmp/hwsclient  >& /dev/null
	echo done.
	echo -n Gathering information:
	ssh $i /tmp/hwsclient/survey.sh >> cluster.xml.$i 2> /dev/null
	echo done
	echo -n Uninstalling Client:
	ssh $i rm -rf /tmp/hwsclient  >& /dev/null
	echo done
	rm -f $i.notdone
	echo Query Complete
done 2> /dev/null  
}

function wait_on_nodes {
	echo -n "Waiting on nodes to complete reports..."
	while ls /LCIT/NODESTAT/*.notdone >& /dev/null; do
		echo -n .
		sleep 1
	done
	echo complete.
}

XML_DIR=/LCIT/nfsexport/NODESTAT
XML_FILE=$XML_DIR/cluster.xml

if [ "$UID" != "0" ]; then
	echo "root access required"
	exit
fi

if [ ! -f $XML_FILE ]; then
	#rm $XML_FILE
    echo '<?xml version='"'"'1.0'"'"'?>' > $XML_FILE
    echo '<!DOCTYPE inventory>' >> $XML_FILE
    echo '<inventory>' >> $XML_FILE
else
    # strip the last line
    #file exists, rip off last line so result remains valid xml

    cat $XML_DIR/cluster.xml |grep -xv `tail -1 /LCIT/nfsexport/NODESTAT/cluster.xml` > $XML_DIR/cluster.xml.new
    mv -f $XML_DIR/cluster.xml.new $XML_DIR/cluster.xml

fi


echo "<survey timestamp='"`date "+%a %B %e %Y %H:%M"`"'>" >> $XML_FILE

nodes=`ls /LCIT/nfsexport/NODESTAT/*.xml`
echo -n Collecting Management Node information...
/LCIT/nfsexport/bin/hwsurvey/client/management_survey.sh >> $XML_FILE 2> /dev/null
echo done

#wait_on_nodes
for i in /LCIT/nfsexport/NODESTAT/cluster.xml.*;
do
	cat $i 2> /dev/null >> $XML_FILE
done

#for i in `lsnodes -p|grep 0\$|awk -F: '{print $1}'`
#do
#	echo "<system name='$i' status='down'/>" >> cluster.xml
#done
echo "</survey>" >> $XML_FILE
echo "</inventory>" >> $XML_FILE
