#!/usr/bin/python

import sys
import socket
import time

def main(argv):
    port = 9191;
    server = sys.argv[1]
    serial = sys.argv[2]
    uuid = sys.argv[3]    

    macs = []
    i = 1
    
    for arg in sys.argv[4:]:
        macs.insert(len(macs),arg)
    
    #create an INET STREAMING socket
    s = socket.socket(
        socket.AF_INET, socket.SOCK_STREAM)

    # connect to LCIT mac server, keep trying until we connect
    while 1:
        try:
            s.connect((server, port))
        except socket.error:
            print "No connection available, trying again..."
            time.sleep(1)
            continue
        
        print "Connected to " + str(server) + ":" + str(port) + "."

        s.send(serial)
        print "Sent " + serial + " as serial number."

        s.send(uuid)
        print "Sent " + uuid + " as uuid."

        for mac in macs:
            
            s.send(str(mac))
            print "\tSent MAC address " + mac

        sys.exit(0)
    
if __name__ == "__main__":
    main(sys.argv[1:])
